
  public clone_entity(entity_id:ID, is_mirror:boolean)  : ID|undefined {
    if (this.entity_states[entity_id] === EntityState.Unknown) {
      throw this.ohno.user.clone_unknown_entity({
        entity_id,
      });
    }

    const entity_to_add = this.get_cloned_entity_data(entity_id, is_mirror);

    // Clone entity variables
    const cloned_variables = _cloneDeep(this.entity_variables[entity_id]);
    this.entity_variables[entity_to_add.entity_id] = cloned_variables;

    // Update runtime data
    // this update must happen before do_add_entity/add_entity are called,
    // because they query RuntimeData to see if they're adding a clone
    // or a non-clone.
    this.runtime_data.clone_created(entity_id, entity_to_add.entity_id);
    if (is_mirror) {
      const rbids = Object.keys(entity_to_add.compiled_block_map);
      for (let i = 0; i < rbids.length; i++) {
        this.runtime_data.set_mirror(rbids[i]);
      }
    }
    this.add_entity(entity_to_add);
    return entity_to_add.entity_id;
  }
